# Generated by Django 2.2.8 on 2021-11-18 14:38

import django.core.validators
from django.db import migrations, models
import logging

logger = logging.getLogger(__name__)


def radius_auto(apps, schema_editor):
    # We can't import the Person model directly as it may be a newer
    # version than this migration expects. We use the historical version.
    Pie = apps.get_model("hmi", "Pie")
    count = 0
    for item in Pie.objects.using(schema_editor.connection.alias).all():
        try:
            int(item.radius)
        except ValueError:
            item.radius = 100
            item.save()
            count += 1

    logger.info('changed %d Pies\n' % count)


class Migration(migrations.Migration):

    dependencies = [
        ('pyscada', '0091_auto_20211118_1019'),
        ('hmi', '0052_auto_20201204_0949'),
    ]

    operations = [
        migrations.RunPython(radius_auto, reverse_code=migrations.RunPython.noop),
        migrations.AddField(
            model_name='pie',
            name='variable_properties',
            field=models.ManyToManyField(blank=True, to='pyscada.VariableProperty'),
        ),
        migrations.AlterField(
            model_name='pie',
            name='innerRadius',
            field=models.PositiveSmallIntegerField(default=0, validators=[django.core.validators.MaxValueValidator(100), django.core.validators.MinValueValidator(0)]),
        ),
        migrations.AlterField(
            model_name='pie',
            name='radius',
            field=models.PositiveSmallIntegerField(default=100, validators=[django.core.validators.MaxValueValidator(100), django.core.validators.MinValueValidator(1)]),
        ),
        migrations.AlterField(
            model_name='pie',
            name='variables',
            field=models.ManyToManyField(blank=True, to='pyscada.Variable'),
        ),
    ]
