# Generated by Django 2.2.8 on 2021-11-25 12:56

from django.db import migrations, models
import logging

logger = logging.getLogger(__name__)

charts_dict = {}


def move_group_display_permissions(apps, schema_editor):
    HMIGroupDisplayPermissions = apps.get_model("hmi", "GroupDisplayPermission")
    HMIPagesGroupDisplayPermissions = apps.get_model("hmi", "PageGroupDisplayPermission")
    HMISlidingPanelMenuGroupDisplayPermission = apps.get_model("hmi", "SlidingPanelMenuGroupDisplayPermission")
    HMIChartGroupDisplayPermission = apps.get_model("hmi", "ChartGroupDisplayPermission")
    HMIControlItemGroupDisplayPermission = apps.get_model("hmi", "ControlItemGroupDisplayPermission")
    HMIFormGroupDisplayPermission = apps.get_model("hmi", "FormGroupDisplayPermission")
    HMIWidgetGroupDisplayPermission = apps.get_model("hmi", "WidgetGroupDisplayPermission")
    HMICustomHTMLPanelGroupDisplayPermission = apps.get_model("hmi", "CustomHTMLPanelGroupDisplayPermission")
    HMIViewGroupDisplayPermission = apps.get_model("hmi", "ViewGroupDisplayPermission")
    HMIProcessFlowDiagramGroupDisplayPermission = apps.get_model("hmi", "ProcessFlowDiagramGroupDisplayPermission")

    db_alias = schema_editor.connection.alias

    hmi_group_display_permissions_set = HMIGroupDisplayPermissions.objects.all()
    count = 0
    pages_dict = []
    for item in hmi_group_display_permissions_set:
        if item.pages.count() and \
                HMIPagesGroupDisplayPermissions.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMIPagesGroupDisplayPermissions(group_display_permission=item,)]
            HMIPagesGroupDisplayPermissions.objects.using(db_alias).bulk_create(i)
            HMIPagesGroupDisplayPermissions.objects.using(db_alias).get(group_display_permission=item).pages.set(item.pages.all())
            count += 1
        if item.sliding_panel_menus.count() and \
                HMISlidingPanelMenuGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMISlidingPanelMenuGroupDisplayPermission(group_display_permission=item,)]
            HMISlidingPanelMenuGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMISlidingPanelMenuGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).sliding_panel_menus.set(item.sliding_panel_menus.all())
            count += 1
        if item.charts.count() and \
                HMIChartGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMIChartGroupDisplayPermission(group_display_permission=item,)]
            HMIChartGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMIChartGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).charts.set(item.charts.all())
            count += 1
        if item.control_items.count() and \
                HMIControlItemGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMIControlItemGroupDisplayPermission(group_display_permission=item,)]
            HMIControlItemGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMIControlItemGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).control_items.set(item.control_items.all())
            count += 1
        if item.forms.count() and \
                HMIFormGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMIFormGroupDisplayPermission(group_display_permission=item,)]
            HMIFormGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMIFormGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).forms.set(item.forms.all())
            count += 1
        if item.widgets.count() and \
                HMIWidgetGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMIWidgetGroupDisplayPermission(group_display_permission=item,)]
            HMIWidgetGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMIWidgetGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).widgets.set(item.widgets.all())
            count += 1
        if item.custom_html_panels.count() and \
                HMICustomHTMLPanelGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMICustomHTMLPanelGroupDisplayPermission(group_display_permission=item,)]
            HMICustomHTMLPanelGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMICustomHTMLPanelGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).custom_html_panels.set(item.custom_html_panels.all())
            count += 1
        if item.views.count() and \
                HMIViewGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMIViewGroupDisplayPermission(group_display_permission=item,)]
            HMIViewGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMIViewGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).views.set(item.views.all())
            count += 1
        if item.process_flow_diagram.count() and \
                HMIProcessFlowDiagramGroupDisplayPermission.objects.using(db_alias).filter(group_display_permission=item).count() == 0:
            i = [HMIProcessFlowDiagramGroupDisplayPermission(group_display_permission=item,)]
            HMIProcessFlowDiagramGroupDisplayPermission.objects.using(db_alias).bulk_create(i)
            HMIProcessFlowDiagramGroupDisplayPermission.objects.using(db_alias).get(group_display_permission=item).process_flow_diagram.set(item.process_flow_diagram.all())
            count += 1
    logger.info('moved %d Groups\n' % count)


class Migration(migrations.Migration):

    dependencies = [
        ('hmi', '0062_auto_20220616_1523'),
    ]

    operations = [
        migrations.RunPython(move_group_display_permissions, reverse_code=migrations.RunPython.noop),
    ]
