# Generated by Django 2.2.8 on 2020-10-05 13:45

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('pyscada', '0062_auto_20201002_0830'),
    ]

    operations = [
        migrations.CreateModel(
            name='ComplexEvent',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('label', models.CharField(default='', max_length=400)),
                ('mail_recipients', models.ManyToManyField(to=settings.AUTH_USER_MODEL)),
                ('variable_to_change', models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='complex_variable_to_change', to='pyscada.Variable')),
            ],
        ),
        migrations.CreateModel(
            name='ComplexEventItem',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('level', models.PositiveSmallIntegerField(choices=[(0, 'informative'), (1, 'ok'), (2, 'warning'), (3, 'alert')], default=0)),
                ('send_mail', models.BooleanField(default=False)),
                ('change_value', models.BooleanField(default=False)),
                ('new_value', models.FloatField(blank=True, default=0, null=True)),
                ('complex_event', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='pyscada.ComplexEvent')),
            ],
        ),
        migrations.CreateModel(
            name='ComplexEventItemVariable',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('fixed_limit_low', models.FloatField(blank=True, default=0, null=True)),
                ('limit_low_type', models.PositiveSmallIntegerField(choices=[(0, 'value < limit'), (1, 'value <= limit')], default=0)),
                ('hysteresis_low', models.FloatField(default=0)),
                ('fixed_limit_high', models.FloatField(blank=True, default=0, null=True)),
                ('limit_high_type', models.PositiveSmallIntegerField(choices=[(0, 'value < limit'), (1, 'value <= limit')], default=0)),
                ('hysteresis_high', models.FloatField(default=0)),
                ('complex_event_item', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='pyscada.ComplexEventItem')),
                ('variable', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='variable', to='pyscada.Variable')),
                ('variable_limit_high', models.ForeignKey(blank=True, default=None, help_text='you can choose either an fixed limit or an variable limit that is\n                                        dependent on the current value of an variable, if you choose a value other than \n                                        none for variable limit the fixed limit would be ignored', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='variable_limit_high', to='pyscada.Variable')),
                ('variable_limit_low', models.ForeignKey(blank=True, default=None, help_text='you can choose either an fixed limit or an variable limit that is\n                                        dependent on the current value of an variable, if you choose a value other than \n                                        none for variable limit the fixed limit would be ignored', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='variable_limit_low', to='pyscada.Variable')),
                ('variable_property', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='pyscada.VariableProperty')),
            ],
        ),
    ]
